{ $HDR$}
{**********************************************************************}
{ Unit archived using Team Coherence                                   }
{ Team Coherence is Copyright 2002 by Quality Software Components      }
{                                                                      }
{ For further information / comments, visit our WEB site at            }
{ http://www.TeamCoherence.com                                         }
{**********************************************************************}
{}
{ $Log:  110548: fMain.pas 
{
{   Rev 1.0    25/10/2004 22:57:20  ANeillans    Version: 9.0.17
{ Verified
}
{-----------------------------------------------------------------------------
 Demo Name: fMain
 Author:    Allen O'Neill
 Purpose:   Basic TCP client demo
 History:
 Date:      13/07/2002 00:55:23
-----------------------------------------------------------------------------

  Notes:

  Demonstrates the following functions:

  (1) ReadLn, WriteLn, ReadInteger
  (2) Using the OnConnect and OnDisconnect events

  Verified:
  Indy 9:
    D7: 25th Oct 2004 by Andy Neillans  
}


unit fMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, IdBaseComponent, IdComponent,
  IdTCPConnection, IdTCPClient, jpeg, ComCtrls, Menus;

type
  TfrmMain = class(TForm)
    IdTCPClient: TIdTCPClient;
    StatusBar1: TStatusBar;
    Panel3: TPanel;
    GroupBox2: TGroupBox;
    Label2: TLabel;
    edtHost: TEdit;
    Label3: TLabel;
    edtPort: TEdit;
    btnConnect: TButton;
    btnDisconnect: TButton;
    Panel1: TPanel;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    btnSendCommand: TButton;
    Edtemperature: TEdit;
    GroupBox5: TGroupBox;
    Button1: TButton;
    Button2: TButton;
    GroupBox6: TGroupBox;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Button3: TButton;
    Edit2: TEdit;
    Edit1: TEdit;
    Edit3: TEdit;
    Panel2: TPanel;
    MainMenu1: TMainMenu;
    Quitter1: TMenuItem;
    GroupBox3: TGroupBox;
    Button4: TButton;
    memo1: TMemo;
    procedure btnDisconnectClick(Sender: TObject);
    procedure btnConnectClick(Sender: TObject);
    procedure btnSendCommandClick(Sender: TObject);
    procedure IdTCPClientDisconnected(Sender: TObject);
    procedure IdTCPClientConnected(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Quitter1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  procedure LockControls(ALock:Boolean);
  end;

var
  frmMain: TfrmMain;
  erreur  : boolean;
implementation

{$R *.dfm}

procedure TfrmMain.LockControls(ALock: Boolean);
var
    i : integer;
begin
for i := 0 to componentcount-1 do
    if TControl(Components[i]).Tag = 99 then
        TControl(Components[i]).Enabled := ALock;
end;

procedure TfrmMain.btnDisconnectClick(Sender: TObject);
begin
if IdTCPClient.Connected then
    try
    IdTCPClient.Disconnect; // we can disconnect from either the server or the client side
    memo1.lines.add('- Client dit -> deconnect.');
    except on E : Exception do
        ShowMessage(E.Message);
    end;
end;

procedure TfrmMain.btnConnectClick(Sender: TObject);

begin
memo1.Clear;
erreur := false;
with IdTCPClient do
    begin
      Host := edtHost.Text;
      Port := StrToint(edtPort.Text);
      memo1.Lines.add('Client envoie -> Demande connexion Tcp  ' + edtHost.Text + ' Port ' + edtPort.Text);
      memo1.Lines.add('- Client demande : Patientez ?');
      Application.ProcessMessages;
      try
      Connect(300); // add a timeout here if you wish, eg: Connect(3000) = timeout after 3 seconds.
      except
      on E : Exception do
          begin
          memo1.Lines.add('- Client dit : Erreur Tcp sur -> ' + edtHost.Text + ' Port ' + edtPort.Text);
          Application.ProcessMessages;
          LockControls(True);
          ShowMessage(E.Message);
          erreur := true;
          end;
      end;
    end;

end;

procedure TfrmMain.btnSendCommandClick(Sender: TObject);
    var
    LCommand, LInString : String;
begin

   LCommand := 'Temp=?'+#$0;
   with IdTCPClient do
    begin
      try
      Write(LCommand);
      memo1.Lines.add('Client envoie -> ' + LCommand);
      LInString := ReadLn;
      memo1.Lines.add('>>> Serveur rpond -> ' + LInString);
      Edtemperature.Text :=  LInString + 'C';
      except
      on E : Exception do
       begin
          memo1.Lines.add('- Client dit : Erreur communication');
          Application.ProcessMessages;
          LockControls(True);
          ShowMessage(E.Message);
         end;
      end;
    end;

end;

procedure TfrmMain.IdTCPClientDisconnected(Sender: TObject);
begin
btnConnect.visible := true;
btnDisconnect.visible := false;
btnSendCommand.Visible :=  true;
LockControls(false);
end;

procedure TfrmMain.IdTCPClientConnected(Sender: TObject);
var
    LString : String;
begin
LString := IdTCPClient.ReadLn;
btnConnect.visible := false;
btnDisconnect.visible := true;
btnSendCommand.Visible :=  true;
memo1.Lines.add('- Client dit : Connexion tablie');
memo1.Lines.add('>>> Serveur rpond -> ' + LString);
LockControls(true);
end;

procedure TfrmMain.Button1Click(Sender: TObject);
     var
    LCommand, LInString : String;
begin

   LCommand := 'OUT4=1'+#$0;
   with IdTCPClient do
    begin
      try
      Write(LCommand);
      memo1.Lines.add('Client envoie -> ' + LCommand);
       LInString := ReadLn;
      memo1.Lines.add('>>> Serveur rpond -> ' + LInString);
      except
      on E : Exception do
       begin
          memo1.Lines.add('- Client dit : Erreur communication');
          Application.ProcessMessages;
          LockControls(True);
          ShowMessage(E.Message);
         end;
      end;
    end;
end;

procedure TfrmMain.Button2Click(Sender: TObject);
 var     LCommand, LInString : String;
begin

   LCommand := 'OUT4=0'+#$0;
   with IdTCPClient do
    begin
      try
      Write(LCommand);
      memo1.Lines.add('Client envoie -> ' + LCommand);
       LInString := ReadLn;
      memo1.Lines.add('>>> Serveur rpond -> ' + LInString);
      except
      on E : Exception do
       begin
          memo1.Lines.add('- Client dit : Erreur communication');
          Application.ProcessMessages;
          LockControls(True);
          ShowMessage(E.Message);
         end;
      end;
    end;
end;

procedure TfrmMain.Edit2Change(Sender: TObject);
begin
    Groupbox6.Caption :=  'Commande : ' + edit2.Text + '='+edit1.Text;
end;

procedure TfrmMain.Edit1Change(Sender: TObject);
begin
     Groupbox6.Caption :=  'Commande : ' + edit2.Text + '='+edit1.Text;
end;

procedure TfrmMain.Button3Click(Sender: TObject);
     var
    LCommand, LInString : String;
begin

   LCommand := edit2.Text + '='+edit1.Text+#$0;
   with IdTCPClient do
    begin
      try
      Write(LCommand);
      memo1.Lines.add('Client envoie -> ' + LCommand);
      LInString := ReadLn;
      memo1.Lines.add('>>> Serveur rpond -> ' + LInString);
      edit3.Text :=   LInString;
      except
      on E : Exception do
       begin
         memo1.Lines.add('- Client dit : Erreur communication');
          Application.ProcessMessages;
          LockControls(True);
          ShowMessage(E.Message);
         end;
      end;
    end;

end;


procedure TfrmMain.Quitter1Click(Sender: TObject);
begin
   application.terminate;
end;

procedure TfrmMain.Button4Click(Sender: TObject);
begin
  memo1.Lines.Clear;
end;

end.
